local f = CreateFrame("Frame", "F2PAddonOptionsFrame", UIParent)
local g = CreateFrame("Frame", "F2PAddonHelpFrame", f)
f.name = "F2PAddon"
f.okay = function (self) return end
f.cancel = function (self) return end


f:Hide()
g:Hide()
f:SetScript("OnShow", function(f)

	local DBLocalSettings = F2PAddon_Variables.Realms[F2PAddonGlobalVars.thisRealm][F2PAddonGlobalVars.myFaction].Settings
	local DBGlobalSettings = F2PAddon_Variables.Settings

    local title = f:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge") --Title for the window
    title:SetPoint("TOPLEFT", 16, -16)
    title:SetText("F2PAddon "..F2PAddonGlobalVars.addonVersion.." Options")

    local info = f:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall") --All the text in the window.  Everything else is positioned around this.
    info:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)  --position top left of this frame relative to bottom left of the title
    info:SetPoint("BOTTOMRIGHT", f, -32, 8) --position bottom right of this frame relative to bottom right of the window
    info:SetNonSpaceWrap(true)
    info:SetJustifyH("LEFT")
    info:SetJustifyV("TOP")
    info:SetText("Author: Yasueh, Aerie Peak US\n\n\n\n|cFFFFD100Channel Name:|r                                                               (Reloads the UI)\n\n\n\n|cFFFFD100Message Blocking:|r\n\n\n              Level 1 and 2 characters (whispers and channel messages).\n\n\n              Level 24 characters (whispers and channel messages).\n\n\n              Whispers from people you don't know, containing the words 'guild' or 'charter'.\n\n\n\n|cFFFFD100Character & alt info tooltips:|r\n\n\n              (Only shows alts that the addon has seen, and that it can confirm are on the same account.)\n\n\n\n|cFFFFD100Account waiting to be upgraded fix:|r\n\n\n              Checking this allows F2PAddon to funtion correctly when a recently upgraded account still has restrictions\n              on chat, for the approximately 72 hours that it takes for Blizzard to fully process the upgrade.\n\n\n\n|cFFFFD100Debugging messages:|r")

	
	
	local channelNameBox = CreateFrame("EditBox", nil, f, "InputBoxTemplate") --Channel name edit box
	channelNameBox:SetPoint("TOPLEFT", f, "TOPLEFT", 105, -70)
	channelNameBox:SetWidth(100);
	channelNameBox:SetHeight(25);
	channelNameBox:SetMaxLetters(16)
	channelNameBox:SetText(F2PAddonGlobalVars.Channel1Name)
	
	local updateChannelNameButton = CreateFrame("Button", nil, f, "UIPanelButtonTemplate")  --Update button for channel name
	updateChannelNameButton:SetPoint("TOPLEFT", f, "TOPLEFT", 210, -72)
	updateChannelNameButton:SetSize(80 ,22)
	updateChannelNameButton:SetText("Update")
	updateChannelNameButton:SetScript("OnClick", function(self, button, down)
		if channelNameBox:GetText() ~= F2PAddonGlobalVars.Channel1Name then
			LeaveChannelByName(F2PAddonGlobalVars.Channel1Name)
			DBLocalSettings.Channel = channelNameBox:GetText()
			ReloadUI()
		end
	end)
	
	
	--[[
	future code here to:
	* Implement a dropdown menu listing all the chat windows that the channel could be shown in.  Dropdowns will need a library such as Ace, as they aren't a part of the default widgets.  Will also allow changes to the channel name to no longer reset which window shows the channel.
	* color picker for the channel text color
	* enable/disable tooltips for player names
	--]]
	
	local lowLevelCheckBox = CreateFrame("CheckButton", nil, f, "UICheckButtonTemplate") -- checkbox to block level 1 and 2s
	lowLevelCheckBox:SetPoint("TOPLEFT", f, "TOPLEFT", 30, -138)
	lowLevelCheckBox:SetScript("OnClick", function(self, button, down)
		if DBLocalSettings.BlockLowLevel == 1 then
			DBLocalSettings.BlockLowLevel = 0
		elseif DBLocalSettings.BlockLowLevel == 0 then
			DBLocalSettings.BlockLowLevel = 1
		end
		if DBLocalSettings.BlockLowLevel == 1 then
			lowLevelCheckBox:SetChecked(true)
		elseif DBLocalSettings.BlockLowLevel == 0 then
			lowLevelCheckBox:SetChecked(false)
		end
	end)


	local twentyFourCheckBox = CreateFrame("CheckButton", nil, f, "UICheckButtonTemplate")-- checkbox to block level 24s
	twentyFourCheckBox:SetPoint("TOPLEFT", f, "TOPLEFT", 30, -168)
	twentyFourCheckBox:SetScript("OnClick", function(self, button, down)
		if DBLocalSettings.BlockTwentyFour == 1 then
			DBLocalSettings.BlockTwentyFour = 0
		elseif DBLocalSettings.BlockTwentyFour == 0 then
			DBLocalSettings.BlockTwentyFour = 1
		end

		if DBLocalSettings.BlockTwentyFour == 1 then
			twentyFourCheckBox:SetChecked(true)
		elseif DBLocalSettings.BlockTwentyFour == 0 then
			twentyFourCheckBox:SetChecked(false)
		end
	end)
	
	
	local guildCheckBox = CreateFrame("CheckButton", nil, f, "UICheckButtonTemplate")-- checkbox to block whispers mentioning guilds or chrarters, from people not on friends list
	guildCheckBox:SetPoint("TOPLEFT", f, "TOPLEFT", 30, -198)
	guildCheckBox:SetScript("OnClick", function(self, button, down)
		if DBLocalSettings.BlockGuild == 1 then
			DBLocalSettings.BlockGuild = 0
		elseif DBLocalSettings.BlockGuild == 0 then
			DBLocalSettings.BlockGuild = 1
		end

		if DBLocalSettings.BlockGuild == 1 then
			guildCheckBox:SetChecked(true)
		elseif DBLocalSettings.BlockGuild == 0 then
			guildCheckBox:SetChecked(false)
		end
	end)

	
	local tooltipCheckBox = CreateFrame("CheckButton", nil, f, "UICheckButtonTemplate")-- checkbox to enable character name tooltips
	tooltipCheckBox:SetPoint("TOPLEFT", f, "TOPLEFT", 30, -265)
	tooltipCheckBox:SetScript("OnClick", function(self, button, down)
		if DBLocalSettings.ShowCharacterTooltips == 1 then
			DBLocalSettings.ShowCharacterTooltips = 0
		elseif DBLocalSettings.ShowCharacterTooltips == 0 then
			DBLocalSettings.ShowCharacterTooltips = 1
		end

		if DBLocalSettings.ShowCharacterTooltips == 1 then
			tooltipCheckBox:SetChecked(true)
		elseif DBLocalSettings.ShowCharacterTooltips == 0 then
			tooltipCheckBox:SetChecked(false)
		end
	end)

	
	local trialFixCheckBox = CreateFrame("CheckButton", nil, f, "UICheckButtonTemplate") --checkbox for trial upgrading fix
	trialFixCheckBox:SetPoint("TOPLEFT", f, "TOPLEFT", 30, -333)
	trialFixCheckBox:SetScript("OnClick", function(self, button, down)
		if DBGlobalSettings.TrialFix then
			DBGlobalSettings.TrialFix = false
		elseif DBGlobalSettings.TrialFix == false then
			DBGlobalSettings.TrialFix = true
		end
		
		if DBGlobalSettings.TrialFix then
			trialFixCheckBox:SetChecked(true)
		elseif DBGlobalSettings.TrialFix == false then
			trialFixCheckBox:SetChecked(false)
		end
	end)
	
	local verboseCheckBox = CreateFrame("CheckButton", nil, f, "UICheckButtonTemplate") --checkbox for dubugging messages
	verboseCheckBox:SetPoint("TOPLEFT", f, "TOPLEFT", 30, -413)
	verboseCheckBox:SetScript("OnClick", function(self, button, down)
		if DBGlobalSettings.Verbose then
			DBGlobalSettings.Verbose = false
		elseif DBGlobalSettings.Verbose == false then
			DBGlobalSettings.Verbose = true
		end

		if DBGlobalSettings.Verbose then
			verboseCheckBox:SetChecked(true)
		elseif DBGlobalSettings.Verbose == false then
			verboseCheckBox:SetChecked(false)
		end
	end)
	
	--These lines repeated here to display the check boxes correctly the first time the window is shown.  The calls inside the per-item SetScripts handle changes after that.
	
	if DBLocalSettings.BlockLowLevel == 1 then
		lowLevelCheckBox:SetChecked(true)
	elseif DBLocalSettings.BlockLowLevel == 0 then
		lowLevelCheckBox:SetChecked(false)
	end
	
	if DBLocalSettings.BlockTwentyFour == 1 then
		twentyFourCheckBox:SetChecked(true)
	elseif DBLocalSettings.BlockTwentyFour == 0 then
		twentyFourCheckBox:SetChecked(false)
	end
	
	if DBLocalSettings.BlockGuild == 1 then
		guildCheckBox:SetChecked(true)
	elseif DBLocalSettings.BlockGuild == 0 then
		guildCheckBox:SetChecked(false)
	end

	if DBLocalSettings.ShowCharacterTooltips == 1 then
		tooltipCheckBox:SetChecked(true)
	elseif DBLocalSettings.ShowCharacterTooltips == 0 then
		tooltipCheckBox:SetChecked(false)
	end
	
	if DBGlobalSettings.TrialFix then
		trialFixCheckBox:SetChecked(true)
	elseif DBGlobalSettings.TrialFix == false then
		trialFixCheckBox:SetChecked(false)
	end
	
	if DBGlobalSettings.Verbose then
		verboseCheckBox:SetChecked(true)
	elseif DBGlobalSettings.Verbose == false then
		verboseCheckBox:SetChecked(false)
	end
end)

g.parent = "F2PAddon"
g.name = "F2PAddon Help"
g.okay = function (self) return end
g.cancel = function (self) return end

g:SetScript("OnShow", function(g)
    local title = g:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge") --Title for the window
    title:SetPoint("TOPLEFT", 16, -16)
    title:SetText("F2PAddon Help")

    local info = g:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall") --All the text in the window.  Everything else is positioned around this.
    info:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)  --position top left of this frame relative to bottom left of the title
    info:SetPoint("BOTTOMRIGHT", g, -32, 8) --position bottom right of this frame relative to bottom right of the window
    info:SetNonSpaceWrap(true)
    info:SetJustifyH("LEFT")
    info:SetJustifyV("TOP")
    info:SetText("|cFFFFD100Invite module commands:\n\n    In channel:|r\n\n        p2p?|cFFFFD100 - Will cause all P2P characters running the addon to respond in the channel if they're available to invite.\n\n\n    Whispered to a P2P:|r\n\n        inv|cFFFFD100 - Will ask the P2P to invite you to a group|r\n\n        lead|cFFFFD100 - Will ask the P2P to pass lead to you before they leave the group (The first person to join the group will\n                  automaticallly be given lead, unless someone else uses this command).|r\n\n        close|cFFFFD100 - Will ask the P2P to leave the group (they will automatically leave after inviting 5 people).\n\n\n\nSlash commands:\n\n    Invite module (only for P2Ps):|r\n\n        /f2pi|cFFFFD100 - Enable/disable the invite module (it's automatically disabled while you're queued for something, in a\n                    dungeon/raid group, or in arenas, battlegrounds or PvP zones).|r\n\n        /f2pi fish|cFFFFD100 - Removes the cap to allow more than 5 players to be invited, and disables the lead and close commands\n                          (used to be used to see where everyone was during a fishing competition, so my shaman could fly\n                          round and give them all water-walking).\n\n\n    BG queueing module:|r\n\n        /f2pq|cFFFFD100 - Toggles the BG pane and the F2PQ windows open closed.  The F2PQ window displays the queue state of\n                    other players in the channel to help with simultaneous queueing or premades of more than 5.|r\n\n        /f2pq reset|cFFFFD100 - Removes all the entries from the F2PQ window, in case you need it clear to start your own group\n                            queue.")
end)

InterfaceOptions_AddCategory(f)
InterfaceOptions_AddCategory(g)